package com.isu.gaswellwatch.utils;


import org.apache.commons.lang3.StringUtils;
import org.apache.commons.lang3.math.NumberUtils;

import java.math.BigDecimal;
import java.math.RoundingMode;
import java.util.Optional;

/**
 * @author <a href="mailto:shilong.wang@alpha-ess.com">王仕龙</a>
 * 2025/2/27 22:57
 */
public class NumberScaleUtils {

    public static String formatTwoScalePositiveNumber(String number) {
        return formatPositiveNumber(number, 2);
    }

    public static String formatPositiveNumber(String number, int scale) {
        if (StringUtils.isNotBlank(number) && NumberUtils.isCreatable(number)) {
            return Optional.of(number).map(value -> {
                BigDecimal decimal = NumberUtils.createBigDecimal(value).setScale(scale, RoundingMode.HALF_UP);
                if (BigDecimal.ZERO.compareTo(decimal) > 0) {
                    return "--";
                }
                return decimal.toString();
            }).orElse(null);
        }
        return number;
    }

    public static String formatTwoScaleNullPositiveNumber(String number) {
        return formatNullPositiveNumber(number, 2);
    }

    public static String formatNullPositiveNumber(String number, int scale) {
        if (StringUtils.isNotBlank(number) && NumberUtils.isCreatable(number)) {
            return Optional.of(number).map(value -> {
                BigDecimal decimal = NumberUtils.createBigDecimal(value).setScale(scale, RoundingMode.HALF_UP);
                if (BigDecimal.ZERO.compareTo(decimal) > 0) {
                    return null;
                }
                return decimal.toString();
            }).orElse(null);
        }
        return number;
    }

}
