package com.isu.gaswellwatch.vo;


import com.fasterxml.jackson.annotation.JsonIgnore;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;
import lombok.experimental.SuperBuilder;
import org.apache.commons.lang3.ObjectUtils;
import org.apache.commons.lang3.math.NumberUtils;

import java.io.Serial;
import java.io.Serializable;
import java.util.Collection;
import java.util.Comparator;
import java.util.stream.Collectors;

/**
 * @author <a href="mailto:shilong.wang@alpha-ess.com">王仕龙</a>
 * 2025/2/27 23:20
 */
@Getter
@Setter
@SuperBuilder
@NoArgsConstructor
public class GasStationVO implements Serializable {

    @Serial
    private static final long serialVersionUID = 573191480595821294L;

    private String name;

    @JsonIgnore
    private Collection<String> pipes;

    public Collection<String> getMainPipes() {
        if (ObjectUtils.isEmpty(this.pipes)) {
            return this.pipes;
        }
        return this.pipes.stream().sorted(Comparator.comparingInt(NumberUtils::createInteger)).collect(Collectors.toList());
    }

}
